{Copyright (C) 2005-2011 (Patrick FRADIN)
Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence 
Publique Générale GNU publiée par la Free Software Foundation (version 2 ou bien toute autre version 
ultérieure choisie par vous).

Ce programme est distribué car potentiellement utile, mais SANS AUCUNE GARANTIE,
 ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation dans un but spécifique.
 Reportez-vous à la Licence Publique Générale GNU pour plus de détails.

Vous devez avoir reçu une copie de la Licence Publique Générale GNU en même temps que ce programme;
 si ce n'est pas le cas, écrivez à la Free Software Foundation,
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, États-Unis.
 }

Unit complex3; {calculs sur les complexes}
{$MODE Delphi}

INTERFACE

USES Sysutils, calculs1 {réels}, listes2 {listes};

CONST 
       digits:byte=4;  {nombre de décimales dans les exportations}

TYPE
    Paffixe=^Taffixe;                      {pointeur sur une liste de complexes}
    Taffixe= object(TCellule)
                  x,y:real;
                  constructor init(x1,y1:real);
                  function en_chaine:string;virtual;   {conversion d'une liste de complexes en chaine (NbDeci:byte)}
                  function evaluer:Paffixe;virtual;   {la liste de complexes est dupliquée}
                  end;

Var jump,sep:Paffixe;            {constante de saut}


function multiplierC(c1,c2:Paffixe):Paffixe;      {calcule c1*c2}
function ajouterC(c1,c2:Paffixe):Paffixe;         {        c1+c2}
function soustraireC(c1,c2:Paffixe):Paffixe;      {        c1-c2}
function diviserC(arg1,arg2:Paffixe):Paffixe;     {        c1/c2}
function puissanceC(c:Paffixe;p:longint):Paffixe; {        c1^p}
function kFoisC(k:real;c:Paffixe):Paffixe;        {         k*c}

function det(A,B:Paffixe):real;                   {déterminant des vecteurs A et B}
function scal(A,B:Paffixe):real;                  {produit scalaire des vecteurs A et B}

function streel(x:real): string;                 {conversion d'un réel sans format scientifique}
function streelS(x:real): string;                {conversion d'un réel avec éventuellement format scientifique}


function IsJump(X:Paffixe):boolean;
function CompPaffixe(a1,a2:Paffixe):boolean;

IMPLEMENTATION

{======================}
function IsJump(X:Paffixe):boolean;
begin IsJump:=(X<>nil) and (X^.x=jump^.x){and (X^.y=jump^.y)}
end;
{===============}
function streel(x:real): string;
var c:byte;
    aux:string;
begin
      //str(x:0:digits,aux);
      //if aux[1]=' ' then delete(aux,1,1);
      //c:=length(aux);
      //while aux[c]='0' do begin delete(aux,c,1);dec(c) end;
     // if aux[c]='.' then delete(aux,c,1);
     // if aux='' then aux:='0';
     // streel:=aux;
     aux:='0.'; for c:=1 to digits do aux:=aux+'#';
     streel:=FormatFloat(aux,x);
end;
function streelS(x:real): string;
begin
     StreelS:=FloatToStr(x)//,ffGeneral,15,7)
end;
{=============== Taffixe =======}
 constructor Taffixe.init(x1,y1:real);
 begin TCellule.init;
       x:=x1;y:=y1
 end;
{=================}
 function Taffixe.evaluer:Paffixe; 
 var index:PCellule;
     liste:Type_liste;
begin
     liste.init;
     liste.ajouter_fin(new(Paffixe,init(x,y)));
     index:=suivant;
     while index<>nil do
           begin
                liste.ajouter_fin(new(Paffixe,init(Paffixe(index)^.x,Paffixe(index)^.y)));
                index:=index^.suivant;
           end; {La liste est maintenant dupliquée dans la variable liste}
     evaluer:=Paffixe(liste.tete);  {on renvoie le contenu de la variable liste}
end;
{=================}
function affixe_en_chaine(UnAffixe:Paffixe):string;
var  r:string;                  {cette chaine contiendra le résultat final, par ex: [0, 1+i, -2*i] }
     Stx,Sty:string;
     signe:string[1];
     x,y:real;
     index:PCellule;            {la variable index parcourt les liste des complexes}
     i:byte;                    {la variable i sert à tester s'il faut un crochet à la fin}
 begin

       index:=Paffixe(Unaffixe);
       if (index<>nil) and (index^.suivant<>nil)  {s'il y a 2 complexes ou plus, il faut des crochets}
       then
          begin
               r:='[';
               i:=2
          end
       else
           begin
                r:='';
                i:=1
           end;          
      while index<>nil do
       begin
            x:=Paffixe(index)^.x; y:=Paffixe(index)^.y;
            if (x=Jump^.x) And (y=Jump^.y) then r:=r+'jump'
               else
               begin
            Stx:=StreelS(abs(x)); Sty:=StreelS(abs(y));
            if (Stx='0') and (Sty='0')                    {on traite le problème des signes et de la valeur 0}
               then r:=r+'0'
               else
                   begin
                        if (Stx<>'0') then
                                          begin
                                               r:=r+StreelS(x);
                                               signe:='+'
                                          end
                                      else signe:='';
                        if (Sty<>'0') then
                                           if y>0 then
                                                      if Sty<>'1' then
                                                                           r:=r+signe+StreelS(y)+'*i'
                                                                  else
                                                                           r:=r+signe+'i'
                                                 else
                                                     if Sty<>'1' then
                                                                          r:=r+StreelS(y)+'*i'
                                                                 else
                                                                          r:=r+'-i';
                   end;
               end;
            if index^.suivant<>nil then r:=r+',';
            index:=index^.suivant;
       end;
      if i=2 then r:=r+']';
      affixe_en_chaine:=r;
 end;
{=================}
 function Taffixe.en_chaine:string; //(NbDeci:byte):string;
 //var oldDigit:byte;
 begin
      //oldDigit:=digits;
      //digits:=NbDeci;                              {on prend NbDeci décimales pour la conversion}
      en_chaine:=affixe_en_chaine(@self);
      //digits:=oldDigit;
 end;

{=================== opérations===================}
function ajouterC(c1,c2:Paffixe):Paffixe;
var r:Paffixe;
begin
     ajouterC:=nil;
     if (c1=nil) or (c2=nil) then exit;
     CalcError:=false;
     r:=new(Paffixe,init(ajouter(c1^.x,c2^.x),ajouter(c1^.y,c2^.y)));
     if CalcError then Kill(Pcellule(r));
     ajouterC:=r;
end;
{=================}
function soustraireC(c1,c2:Paffixe):Paffixe;
var r:Paffixe;
begin
     soustraireC:=nil;
     if (c1=nil) or (c2=nil) then exit;
     CalcError:=false;
     r:=new(Paffixe,init(ajouter(c1^.x,-c2^.x),ajouter(c1^.y,-c2^.y)));
     if CalcError then Kill(Pcellule(r));
     soustraireC:=r;
end;
{=================}
function multiplierC(c1,c2:Paffixe):Paffixe;
var r:Paffixe;
begin
     multiplierC:=nil;
     if (c1=nil) or (c2=nil) then exit;
     CalcError:=false;
           r:=new(Paffixe,init(ajouter(multiplier(c1^.x,c2^.x),-multiplier(c1^.y,c2^.y)),
                               ajouter(multiplier(c1^.x,c2^.y),multiplier(c2^.x,c1^.y))));
     if CalcError then Kill(Pcellule(r));
     multiplierC:=r;
end;
{=================}
function kFoisC(k:real;c:Paffixe):Paffixe;
var r:Paffixe;
begin
     kFoisC:=nil;
     if (c=nil) then exit;
     CalcError:=false;
           r:=new(Paffixe,init(multiplier(k,c^.x),multiplier(k,c^.y) ));
     if CalcError then Kill(Pcellule(r));
     kFoisC:=r;
end;
{=================}
function diviserC(arg1,arg2:Paffixe):Paffixe;
var r:Paffixe;
    x:real;
begin
     diviserC:=nil;
     if (arg1=nil) or (arg2=nil) then exit;
     CalcError:=false;
     x:=ajouter(sqr(arg2^.x),sqr(arg2^.y));
     if CalcError then exit;
     r:=new(Paffixe,init(
             diviser(ajouter(multiplier(arg1^.x,arg2^.x),multiplier(arg1^.y,arg2^.y)),x),
             diviser(ajouter(-multiplier(arg1^.x,arg2^.y),multiplier(arg2^.x,arg1^.y)),x)));
     if CalcError then Kill(Pcellule(r));
     diviserC:=r
end;
{=================}
function puissanceC(c:Paffixe;p:longint):Paffixe;
var r,r1:Paffixe;
    u:real;
begin
     r:=nil;
     CalcError:=false;
     if p=0 then if (c^.x=0) and (c^.y=0) then
                           else r:=new(Paffixe,init(1,0))
            else
    if p>0 then if (c^.x=0) and (c^.y=0) then r:=new(Paffixe,init(0,0))
                          else
                if odd(p) then begin r1:=puissanceC(c,p-1);
                                     if r1<>nil then begin
                                                          r:=multiplierC(c,r1);
                                                          Kill(Pcellule(r1))
                                                     end
                               end
                          else begin r1:=puissanceC(c,p div 2);
                                     if r1<>nil then begin
                                                          r:=multiplierC(r1,r1);
                                                          Kill(Pcellule(r1))
                                                     end
                               end
           else
     if (c^.x=0) and (c^.y=0) then
               else begin r1:= puissanceC(c,-p);
                          if r1<>nil then begin
                                          u:=ajouter(sqr(r1^.x),sqr(r1^.y));
                                          if not CalcError then
                                          r:=new(Paffixe,init(diviser(r1^.x,u),diviser(-r1^.y,u)));
                                          Kill(Pcellule(r1))
                                          end;
                    end;
     puissanceC:=r;
end;
{=================}
function det(A,B:Paffixe):real;
begin
      if (A=nil) or (B=nil) then CalcError:=true
                            else
      det:=ajouter(multiplier(A^.x,B^.y),-multiplier(A^.y,B^.x));
end;
{=================}
function scal(A,B:Paffixe):real;
 begin
      if (A=nil) or (B=nil) then CalcError:=true
                            else
      scal:=ajouter(multiplier(A^.x,B^.x),multiplier(A^.y,B^.y));
 end;
{=================}
function CompPaffixe(a1,a2:Paffixe):boolean;
var index1,index2:Paffixe;
    ok:boolean;
begin
     ok :=true; index1:=a1; index2:=a2;
     while ok and (index1<>Nil) and (index2<>Nil) do
           begin
                ok:= (index1^.x=index2^.x) And (index1^.y=index2^.y);
                index1:=Paffixe(index1^.suivant);
                index2:=Paffixe(index2^.suivant);
           end;
     ok:= ok and (index1=Nil) and (index2=Nil);
     result:=ok
end;

END.


